﻿using System;
using System.Configuration;

namespace BenchmarkTool
{
    public class Config
    {
        public static DateTime GetStartTime()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.StartTime];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.StartTime));
            DateTime.TryParse(val, out DateTime date);
            return date;
        }

        public static int GetBatchTimeOffset()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.BatchTimeOffset];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.BatchTimeOffset));
            int.TryParse(val, out int offset);
            return offset;
        }

        public static int GetGlobalTimeOffset()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.GlobalTimeOffset];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.GlobalTimeOffset));
            int.TryParse(val, out int offset);
            return offset;
        }

        public static int GetBatchSize()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.BatchSize];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.BatchSize));
            int.TryParse(val, out int batchSize);
            return batchSize;
        }

        public static int GetLoop()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.Loop];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.Loop));
            int.TryParse(val, out int loop);
            return loop;
        }

        public static int GetClientNumber()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.ClientNumber];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.ClientNumber));
            int.TryParse(val, out int clients);
            return clients;
        }

        public static int GetSensorNumber()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.SensorNumber];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.SensorNumber));
            int.TryParse(val, out int sensors);
            return sensors;
        }

        public static int GetTestLoop()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.TestLoop];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.TestLoop));
            int.TryParse(val, out int loop);
            return loop;
        }

        public static string GetTargetDatabase()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.TargetDatabase];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.TargetDatabase));
            return val;
        }

        public static string GetTimescaleConnection()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.TimescaleConnection];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.TimescaleConnection));
            return val;
        }

        public static string GetMySQLConnection()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.MySQLConnection];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.MySQLConnection));
            return val;
        }

        public static string GetMetricsCSVPath()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.MetricsCSVPath];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.MetricsCSVPath));
            return val;
        }

        public static string GetInfluxHost()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.InfluxDBHost];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.InfluxDBHost));
            return val;
        }

        public static string GetInfluxToken()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.InfluxDBToken];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.InfluxDBToken));
            return val;
        }

        public static string GetInfluxBucket()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.InfluxDBBucket];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.InfluxDBBucket));
            return val;
        }

        public static string GetInfluxOrganization()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.InfluxDBOrganization];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.InfluxDBOrganization));
            return val;
        }

        public static string GetClickhouseHost()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.ClickhouseHost];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.ClickhouseHost));
            return val;
        }

        public static string GetClickhouseUser()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.ClickhouseUser];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.ClickhouseUser));
            return val;
        }

        public static string GetClickhousePort()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.ClickhousePort];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.ClickhousePort));
            return val;
        }

        public static string GetClickhouseDatabase()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.ClickhouseDatabase];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.ClickhouseDatabase));
            return val;
        }

        public static string GetOperation()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.Operation];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.Operation));
            return val;
        }


        public static string GetAggregationFunction()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.AggregationFunction];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.AggregationFunction));
            return val;
        }

        public static string GetAggregationInterval()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.AggregationInterval];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.AggregationInterval));
            return val;
        }

        public static long GetDurationMinutes()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.DurationMinutes];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.DurationMinutes));
            long.TryParse(val, out long duration);
            return duration;
        }


        public static string GetTimescaleRangeQuery()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.TimescaleDBRangeQuery];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.TimescaleDBRangeQuery));
            return val;
        }

        public static string GetSensorsFilterString()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.SensorsFilter];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.SensorsFilter));
            return val;
        }

        public static int[] GetSensorsFilter()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.SensorsFilter];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.SensorsFilter));
            return Array.ConvertAll(val.Split(","), s => int.TryParse(s, out var x) ? x : -1);
        }


        public static int GetSensorID()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.SensorID];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.SensorID));
            int.TryParse(val, out int sensorId);
            return sensorId;
        }

        public static double GetMaxValue()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.MaxValue];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.MaxValue));
            double.TryParse(val, out double max);
            return max;
        }

        public static double GetMinValue()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.MinValue];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.MinValue));
            double.TryParse(val, out double min);
            return min;
        }

        public static int GetFirstSensorID()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.FirstSensorID];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.FirstSensorID));
            int.TryParse(val, out int sensorId);
            return sensorId;
        }

        public static int GetSecondSensorID()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.SecondSensorID];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.SecondSensorID));
            int.TryParse(val, out int sensorId);
            return sensorId;
        }

        public static int[] GetClientNumberOptions()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.ClientNumberOptions];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.ClientNumberOptions));
            return Array.ConvertAll(val.Split(","), s => int.TryParse(s, out var x) ? x : -1);
        }

      

        public static int[] GetBatchSizeOptions()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.BatchSizeOptions];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.BatchSizeOptions));
            return Array.ConvertAll(val.Split(","), s => int.TryParse(s, out var x) ? x : -1);
        }

        public static int GetDaySpan()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.DaySpan];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.DaySpan));
            int.TryParse(val, out int days);
            return days;
        }

        public static int GetHourSpan()
        {
            var val = ConfigurationManager.AppSettings[ConfigurationKeys.HourSpan];
            if (String.IsNullOrEmpty(val))
                throw new Exception(String.Format("Null or empty app settings val for key={0}", ConfigurationKeys.HourSpan));
            int.TryParse(val, out int hours);
            return hours;
        }
    }
}
