﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Text;

namespace BenchmarkTool
{
    class DatabaseFactory    {

        string database;

        public DatabaseFactory() {
            database = Config.GetTargetDatabase();
        }
        public IDatabase Create()
        {
            switch (database)
            {
                case Constants.TimescaleDBClass:
                    return new TimescaleDB();
                case Constants.InfluxDBClass:
                    return new InfluxDB();
                case Constants.ClickhouseClass:
                    return new ClickhouseDB();
                case Constants.mYsqlMySQLClass:
                    return new MySQLDB();
                default:
                    throw new NotImplementedException();
            }
        }
    }
}

