﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;

namespace BenchmarkTool
{
    public interface IDatabase
    {
        void init() ;

        void cleanup();

        void close();

        Task<QueryStatus> WriteBatch(Batch batch);

        QueryStatus RangeQueryRaw(RangeQuery rangeQuery);

        QueryStatus RangeQueryAgg(RangeQuery rangeQuery);

        QueryStatus OutOfRangeQuery(OORangeQuery query);

        QueryStatus AggregatedDifferenceQuery(ComparisionQuery query);

        QueryStatus StandardDevQuery(SpecificQuery query);

    }
}
