﻿using CsvHelper;
using Serilog;
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace BenchmarkTool
{
    public interface IMetric
    {
        public double ExecutionTime { get; set; }
        public  Double TotalOperationLatency { get; set; }

        public Double SucceededOperationDataPointsNumber { get; set; }

        public Double FailedOperationDataPointsNumber { get; set; }

        public Double SucceededOperationsNumber { get; set; }

        public Double FailedOperationsNumber { get; set; }

        public string PerformedOperation { get; set; }

        public int ClientsNumber { get; set; }


        public void IncrementSucceededPoints(double pointNum);


        public void IncrementSucceededOperations(double nb);

        public void IncrementFailedPoints(double pointNum);

        public void IncrementFailedOperations(double nb);

        public void IncrementOperationLatency(double latency);

        public void Merge(IMetric metric);

        public void WriteToCSV();
        
    }
}
