﻿using CsvHelper.Configuration;
using System;
using System.Collections.Generic;
using System.Text;

namespace BenchmarkTool
{
    public class LogRecordWrite
    {
        public DateTime Date { get; set; }
        public double SucceededDataPoints { get; set; }
        public double SucceededOperations { get; set; }
        public double FailedDataPoints { get; set; }
        public double FailedOperations { get; set; }
        public string Operation { get; set; }
        public string TargetDatabase { get; set; }
        public double Latency { get; set; }
        public int ClientsNumber { get; set; }
        public int BatchSize { get; set; }
        public int Loop { get; set; }

        public int SensorsNumber { get; set; }

        public LogRecordWrite(double latency, double succeededPoints, double failedPoints, double succeededOperations, double failedOperations, string operation, int clientsNb, int batchSize, int sensorsNb)
        {
            Latency = latency;
            SucceededDataPoints = succeededPoints;
            SucceededOperations = succeededOperations;
            FailedDataPoints = failedPoints;
            FailedOperations = failedOperations;
            Operation = operation;
            Date = DateTime.Now;
            TargetDatabase = Config.GetTargetDatabase();
            SensorsNumber = sensorsNb;
            BatchSize = batchSize;
            ClientsNumber = clientsNb;
            Loop = Config.GetLoop();
        }
    }

    //public sealed class LogMap : ClassMap<LogRecordWrite>
    //{
    //    public LogMap()
    //    {
    //        Map(x => x.Latency).Name("Latency");
    //        Map(x => x.Operation).Name("Operation");
    //        Map(x => x.SucceededDataPoints).Name("SucceededDataPoints");
    //        Map(x => x.TargetDatabase).Name("TargetDatabase");
    //        Map(x => x.SucceededOperations).Name("SucceededOperations");
    //        Map(x => x.FailedDataPoints).Name("FailedDataPoints");
    //        Map(x => x.FailedOperations).Name("FailedOperations");
    //        Map(x => x.ClientsNumber).Name("ClientsNumber");
    //        Map(x => x.Loop).Name("Loop");    
    //    }
    //}
}
