﻿using MySqlConnector;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BenchmarkTool
{
    public class MySQLDB : IDatabase
    {
        private MySqlConnection connection;
        public QueryStatus AggregatedDifferenceQuery(ComparisionQuery query)
        {
            throw new NotImplementedException();
        }

        public void cleanup()
        {
            throw new NotImplementedException();
        }

        public void close()
        {
            try
            {
                if (connection != null)
                    connection.Close();
            }
            catch (Exception ex)
            {
                Serilog.Log.Error(String.Format("Failed to close MySQL. Exception: {0}", ex.ToString()));
            }
        }

        public void init()
        {
            try
            {
                connection = new MySqlConnection(Config.GetMySQLConnection());

                connection.Open();
            }
            catch (Exception ex)
            {
                Serilog.Log.Error(String.Format("Failed to initialize MySQL. Exception: {0}", ex.ToString()));
            }
        }

        public QueryStatus OutOfRangeQuery(OORangeQuery query)
        {
            throw new NotImplementedException();
        }

        public QueryStatus RangeQueryAgg(RangeQuery rangeQuery)
        {
            throw new NotImplementedException();
        }

        public QueryStatus RangeQueryRaw(RangeQuery rangeQuery)
        {
            throw new NotImplementedException();
        }

        public QueryStatus StandardDevQuery(SpecificQuery query)
        {
            throw new NotImplementedException();
        }

        public async Task<QueryStatus> WriteBatch(Batch batch)
        {
            try
            {

                StringBuilder sCommand = new StringBuilder("INSERT INTO sensor_data (`time`, sensor_id, `value`) VALUES ");

                List<string> Rows = new List<string>();
               

                foreach (var record in batch.Records)
                {
                    Rows.Add(string.Format("('{0}',{1},{2})", record.Time.ToString("yyyy-MM-dd HH:mm:ss"), record.SensorID, record.Value));
                }


                sCommand.Append(string.Join(",", Rows));
                sCommand.Append(";");
                using (MySqlCommand myCmd = new MySqlCommand(sCommand.ToString(), connection))
                {
                    myCmd.CommandType = CommandType.Text;
                    myCmd.ExecuteNonQuery();
                }


                return new QueryStatus(true);
            }

            catch (Exception ex)
            {
                Serilog.Log.Error(String.Format("Failed to insert batch into MySQL. Exception: {0}", ex.ToString()));
                return new BenchmarkTool.QueryStatus(false, 0, ex, ex.ToString());
            }




        }


    }
}
