﻿using CsvHelper;
using Serilog;
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace BenchmarkTool
{
    public abstract class PerformanceMetricBase : IMetric
    {
        protected PerformanceMetricBase()
        {
        }

        public double ExecutionTime { get; set; }
        public  Double TotalOperationLatency { get;  set; }

        public Double SucceededOperationDataPointsNumber { get;  set; }

        public Double FailedOperationDataPointsNumber { get;  set; }

        public Double SucceededOperationsNumber { get;  set; }

        public Double FailedOperationsNumber { get;  set; }

        public string PerformedOperation { get; set; }

        public int ClientsNumber{ get; set; }


        public void IncrementSucceededPoints(double pointNum)
        {
            SucceededOperationDataPointsNumber += pointNum;
        }

        public void IncrementSucceededOperations(double nb)
        {
            SucceededOperationsNumber += nb;
        }

        public void IncrementFailedPoints(double pointNum)
        {
            FailedOperationDataPointsNumber += pointNum;
        }

        public void IncrementFailedOperations( double nb)
        {
            FailedOperationsNumber += nb;
        }

        public void IncrementOperationLatency(double latency)
        {
            TotalOperationLatency+= latency;
        }

        public void Merge(IMetric metric)
        {            
            IncrementOperationLatency(metric.TotalOperationLatency);
            IncrementFailedOperations(metric.FailedOperationsNumber);
            IncrementFailedPoints(metric.FailedOperationDataPointsNumber);
            IncrementSucceededOperations(metric.SucceededOperationsNumber);
            IncrementSucceededPoints(metric.SucceededOperationDataPointsNumber);           
        }


        public abstract void WriteToCSV();

      
    }
}
