﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Text;

namespace BenchmarkTool
{
    class RecordFactory
    {
        string database;

        public RecordFactory()
        {
            database = Config.GetTargetDatabase();
        }
        public IRecord Create(int sensorId, DateTime timestamp, float value)
        {
            return database switch
            {
                Constants.TimescaleDBClass => new RecordTimescaleDB(sensorId, timestamp, value),
                Constants.InfluxDBClass => new RecordInflux(sensorId, timestamp, value),
                Constants.ClickhouseClass => new RecordClickhouse(sensorId, timestamp, value),
                Constants.mYsqlMySQLClass => new RecordMySQLDB(sensorId, timestamp, value),

                _ => throw new NotImplementedException(),
            };
        }
    }
}
