﻿using InfluxDB.Client.Core;
using Serilog;
using System;
using System.Collections.Generic;
using System.Text;

namespace BenchmarkTool
{
    [Measurement(Constants.DatabaseName)]
    public class RecordInflux : IRecord
    {
        [Column(Constants.SensorID, IsTag = true)]
        public int SensorID { get; set; }
        [Column(Constants.Value)]

        public float Value { get; set; }
        [Column(IsTimestamp = true)]

        public DateTime Time { get; set; }

        public RecordInflux(int sensorId, DateTime timestamp, float value)
        {
            SensorID = sensorId;
            Time = TimeZoneInfo.ConvertTimeToUtc(timestamp);
            Value = value;
        }
    } 

}
